Object.defineProperty(exports, "__esModule", { value: true });
const extractEnvironmentVariables = (path, codeAsString) => {
    path.node.arguments[1].properties.forEach((environmentProperty) => {
        const keyValueAsString = codeAsString.substring(environmentProperty.start, environmentProperty.end);
        const finalObj = {};
        finalObj.required = !keyValueAsString.includes('default');
        if (keyValueAsString.includes('devDefault')) {
            finalObj.devRequired = false;
        }
        console.log(keyValueAsString.substring(0, keyValueAsString.indexOf(':') + 1), finalObj);
    });
};
function envLogger() {
    return {
        visitor: {
            CallExpression(path, state) {
                var _a, _b, _c, _d, _e, _f;
                if (((_a = path.node.callee) === null || _a === void 0 ? void 0 : _a.name) === 'cleanEnv' ||
                    (((_c = (_b = path.node.callee) === null || _b === void 0 ? void 0 : _b.object) === null || _c === void 0 ? void 0 : _c.name) === 'envalid' && ((_e = (_d = path.node.callee) === null || _d === void 0 ? void 0 : _d.property) === null || _e === void 0 ? void 0 : _e.name) === 'cleanEnv')) {
                    extractEnvironmentVariables(path, state.file.code);
                }
                if (((_f = path.node.callee) === null || _f === void 0 ? void 0 : _f.type) === 'SequenceExpression') {
                    let hasCleanEnvString = false;
                    path.node.callee.expressions.forEach((seqExp) => {
                        var _a, _b;
                        if (((_a = seqExp === null || seqExp === void 0 ? void 0 : seqExp.object) === null || _a === void 0 ? void 0 : _a.name) === 'cleanEnv') {
                            hasCleanEnvString = true;
                        }
                        if (((_b = seqExp === null || seqExp === void 0 ? void 0 : seqExp.property) === null || _b === void 0 ? void 0 : _b.name) === 'cleanEnv') {
                            hasCleanEnvString = true;
                        }
                    });
                    if (hasCleanEnvString) {
                        extractEnvironmentVariables(path, state.file.code);
                    }
                }
            },
            VariableDeclarator(path) {
                var _a, _b, _c, _d, _e, _f, _g;
                if (((_b = (_a = path.node) === null || _a === void 0 ? void 0 : _a.id) === null || _b === void 0 ? void 0 : _b.name) === 'publicEnv') {
                    console.log('Following env variables are set');
                    if ((_c = path.node) === null || _c === void 0 ? void 0 : _c.init.elements) {
                        (_e = (_d = path.node) === null || _d === void 0 ? void 0 : _d.init) === null || _e === void 0 ? void 0 : _e.elements.forEach((stringNode) => {
                            console.log(stringNode === null || stringNode === void 0 ? void 0 : stringNode.value);
                        });
                    }
                    else if ((_g = (_f = path.node) === null || _f === void 0 ? void 0 : _f.init) === null || _g === void 0 ? void 0 : _g.value) {
                        console.log(path.node.init.value);
                    }
                }
            },
        },
    };
}
exports.default = envLogger;
//# sourceMappingURL=envLogger.js.map